
#ifndef DEBUGGING
#define DEBUGGING

//#include <stdio.h>
//would rather not include stdio.h in pretty much ALL source files... Debugging.h is included in Globals.h!

#define	Debug(a,b,c)							DoDebug(__FILE__,__LINE__,a,b,c)
#define	Assert(check, a, b, c)					DoAssert(__FILE__,__LINE__,check,a,b,c)
#define	AssertUnhandledValue(check,b,c)			Assert(check, kDbgType_UnhandledValue, b, c)
#define	AssertUnhandledValue2(check,Value)		AssertUnhandledValue(check, &Value, sizeof(Value))
#define	AssertSanity(check)						Assert(check, kDbgType_SanityFailure, NULL, 0)
#define	AssertCreation(check)					Assert(check, kDbgType_CreationFailed, NULL, 0)
#define	AssertError(check,b,c)					Assert(check, kDbgType_ErrorReturned, b, c)
#define	AssertError2(Error)						AssertError((Error != noErr), &Error, sizeof(Error))
#define	AssertMessage(check, Message, Length)	Assert(check, kDbgType_Message, Message, Length)
#define	AssertMessage2(check, Message)			AssertMessage(check, Message, strlen(Message))

enum {
	kDbgType_UnhandledValue			= 1,
	kDbgType_SanityFailure			= 2,
	kDbgType_CreationFailed			= 3,
	kDbgType_ErrorReturned			= 4,
	kDbgType_Message				= 5
};

bool	DoAssert(const char *, const int, bool, int, void *, int);
void	DoDebug(const char *, const int, int, void *, int);
void	DbgWriteHex(void *, char *, int);//FILE *, char *, int

#endif//DEBUGGING
