
#ifndef UTILITES
#define UTILITIES

enum {
	kKeyCode_Home				= 0x0001,
							//	= 0x0002,//unknown at this time
							//	= 0x0003,//unknown at this time
	kKeyCode_End				= 0x0004,
	kKeyCode_Backspace			= 0x0008,
	kKeyCode_Tab				= 0x0009,
	kKeyCode_LineFeed			= 0x000a,
	kKeyCode_PageUp				= 0x000b,
	kKeyCode_PageDown			= 0x000c,
	kKeyCode_CarriageReturn		= 0x000d,
							//	= 0x000e,//unknown at this time
							//	= 0x000f,//unknown at this time
	kKeyCode_FunctionKey		= 0x0010,
							/*	= 0x0011, through
								= 0x001a, are not known at this time*/
	kKeyCode_Escape				= 0x001b,
	kKeyCode_LeftArrow			= 0x001c,
	kKeyCode_RightArrow			= 0x001d,
	kKeyCode_UpArrow			= 0x001e,
	kKeyCode_DownArrow			= 0x001f,
	kKeyCode_Space				= 0x0020,	//' '
	kKeyCode_ExclamationPoint	= 0x0021,	//'!'
	kKeyCode_DoubleQuote		= 0x0022,	//'"'
	kKeyCode_Pound				= 0x0023,	//'#'
	kKeyCode_Dollar				= 0x0024,	//'$'
	kKeyCode_Percent			= 0x0025,	//'%'
	kKeyCode_Ampersand			= 0x0026,	//'&'
	kKeyCode_SingleQuote		= 0x0027,	//'\''
	kKeyCode_OpenParenthesi		= 0x0028,	//'('
	kKeyCode_CloseParenthesi	= 0x0029,	//')'
	kKeyCode_Asterisk			= 0x002a,	//'*'
	kKeyCode_Plus				= 0x002b,	//'+'
	kKeyCode_Comma				= 0x002c,	//','
	kKeyCode_Minus				= 0x002d,	//'-'
	kKeyCode_Period				= 0x002e,	//'.'
	kKeyCode_ForwardSlash		= 0x002f,	//'/'
	kKeyCode_Zero				= 0x0030,	//'0'
	kKeyCode_One				= 0x0031,	//'1'
	kKeyCode_Two				= 0x0032,	//'2'
	kKeyCode_Three				= 0x0033,	//'3'
	kKeyCode_Four				= 0x0034,	//'4'
	kKeyCode_Five				= 0x0035,	//'5'
	kKeyCode_Six				= 0x0036,	//'6'
	kKeyCode_Seven				= 0x0037,	//'7'
	kKeyCode_Eight				= 0x0038,	//'8'
	kKeyCode_Nine				= 0x0039,	//'9'
	kKeyCode_Colon				= 0x003a,	//':'
	kKeyCode_Semicolon			= 0x003b,	//';'
	kKeyCode_LessThan			= 0x003c,	//'<'
	kKeyCode_Equals				= 0x003d,	//'='
	kKeyCode_GreaterThan		= 0x003e,	//'>'
	kKeyCode_QuestionMark		= 0x003f,	//'?'
	kKeyCode_At					= 0x0040,	//'@'
	kKeyCode_UppercaseA			= 0x0041,	//'A'
	kKeyCode_UppercaseB			= 0x0042,	//'B'
	kKeyCode_UppercaseC			= 0x0043,	//'C'
	kKeyCode_UppercaseD			= 0x0044,	//'D'
	kKeyCode_UppercaseE			= 0x0045,	//'E'
	kKeyCode_UppercaseF			= 0x0046,	//'F'
	kKeyCode_UppercaseG			= 0x0047,	//'G'
	kKeyCode_UppercaseH			= 0x0048,	//'H'
	kKeyCode_UppercaseI			= 0x0049,	//'I'
	kKeyCode_UppercaseJ			= 0x004a,	//'J'
	kKeyCode_UppercaseK			= 0x004b,	//'K'
	kKeyCode_UppercaseL			= 0x004c,	//'L'
	kKeyCode_UppercaseM			= 0x004d,	//'M'
	kKeyCode_UppercaseN			= 0x004e,	//'N'
	kKeyCode_UppercaseO			= 0x004f,	//'O'
	kKeyCode_UppercaseP			= 0x0050,	//'P'
	kKeyCode_UppercaseQ			= 0x0051,	//'Q'
	kKeyCode_UppercaseR			= 0x0052,	//'R'
	kKeyCode_UppercaseS			= 0x0053,	//'S'
	kKeyCode_UppercaseT			= 0x0054,	//'T'
	kKeyCode_UppercaseU			= 0x0055,	//'U'
	kKeyCode_UppercaseV			= 0x0056,	//'V'
	kKeyCode_UppercaseW			= 0x0057,	//'W'
	kKeyCode_UppercaseX			= 0x0058,	//'X'
	kKeyCode_UppercaseY			= 0x0059,	//'Y'
	kKeyCode_UppercaseZ			= 0x005a,	//'Z'
	kKeyCode_OpenBracket		= 0x005b,	//'['
	kKeyCode_Backslash			= 0x005c,	//'\\'
	kKeyCode_CloseBracket		= 0x005d,	//']'
	kKeyCode_Power				= 0x005e,	//'^'
	kKeyCode_Underscore			= 0x005f,	//'_'
	kKeyCode_Diacritical		= 0x0060,	//'`'
	kKeyCode_LowercaseA			= 0x0061,	//'a'
	kKeyCode_LowercaseB			= 0x0062,	//'b'
	kKeyCode_LowercaseC			= 0x0063,	//'c'
	kKeyCode_LowercaseD			= 0x0064,	//'d'
	kKeyCode_LowercaseE			= 0x0065,	//'e'
	kKeyCode_LowercaseF			= 0x0066,	//'f'
	kKeyCode_LowercaseG			= 0x0067,	//'g'
	kKeyCode_LowercaseH			= 0x0068,	//'h'
	kKeyCode_LowercaseI			= 0x0069,	//'i'
	kKeyCode_LowercaseJ			= 0x006a,	//'j'
	kKeyCode_LowercaseK			= 0x006b,	//'k'
	kKeyCode_LowercaseL			= 0x006c,	//'l'
	kKeyCode_LowercaseM			= 0x006d,	//'m'
	kKeyCode_LowercaseN			= 0x006e,	//'n'
	kKeyCode_LowercaseO			= 0x006f,	//'o'
	kKeyCode_LowercaseP			= 0x0070,	//'p'
	kKeyCode_LowercaseQ			= 0x0071,	//'q'
	kKeyCode_LowercaseR			= 0x0072,	//'r'
	kKeyCode_LowercaseS			= 0x0073,	//'s'
	kKeyCode_LowercaseT			= 0x0074,	//'t'
	kKeyCode_LowercaseU			= 0x0075,	//'u'
	kKeyCode_LowercaseV			= 0x0076,	//'v'
	kKeyCode_LowercaseW			= 0x0077,	//'w'
	kKeyCode_LowercaseX			= 0x0078,	//'x'
	kKeyCode_LowercaseY			= 0x0079,	//'y'
	kKeyCode_LowercaseZ			= 0x007a,	//'z'
	kKeyCode_OpenBrace			= 0x007b,	//'{'
	kKeyCode_VerticalBar		= 0x007c,	//'|'
	kKeyCode_CloseBrace			= 0x007d,	//'}'
	kKeyCode_Tilde				= 0x007e,	//'~'
	kKeyCode_Delete				= 0x007f,
	/*Anything higher than 0x007f is not ASCII standard*/
	kKeyCode_Bullet				= 0xffa5	//''
};

enum {
	kKeyCode_Return				= kKeyCode_CarriageReturn,
	kKeyCode_Multiply			= kKeyCode_Asterisk,
	kKeyCode_Slash				= kKeyCode_ForwardSlash,
	kKeyCode_TicTacToe			= kKeyCode_Pound,
	kKeyCode_And				= kKeyCode_Ampersand,
	kKeyCode_Quote				= kKeyCode_DoubleQuote,
	
	kKeyCode_F1					= kKeyCode_FunctionKey,
	kKeyCode_F2					= kKeyCode_FunctionKey,
	kKeyCode_F3					= kKeyCode_FunctionKey,
	kKeyCode_F4					= kKeyCode_FunctionKey,
	kKeyCode_F5					= kKeyCode_FunctionKey,
	kKeyCode_F6					= kKeyCode_FunctionKey,
	kKeyCode_F7					= kKeyCode_FunctionKey,
	kKeyCode_F8					= kKeyCode_FunctionKey,
	kKeyCode_F9					= kKeyCode_FunctionKey,
	kKeyCode_F10				= kKeyCode_FunctionKey,
	kKeyCode_F11				= kKeyCode_FunctionKey,
	kKeyCode_F12				= kKeyCode_FunctionKey,
	kKeyCode_F13				= kKeyCode_FunctionKey,
	kKeyCode_F14				= kKeyCode_FunctionKey,
	kKeyCode_F15				= kKeyCode_FunctionKey,
	
	kKeyCode_CapitalA			= kKeyCode_UppercaseA,
	kKeyCode_CapitalB			= kKeyCode_UppercaseB,
	kKeyCode_CapitalC			= kKeyCode_UppercaseC,
	kKeyCode_CapitalD			= kKeyCode_UppercaseD,
	kKeyCode_CapitalE			= kKeyCode_UppercaseE,
	kKeyCode_CapitalF			= kKeyCode_UppercaseF,
	kKeyCode_CapitalG			= kKeyCode_UppercaseG,
	kKeyCode_CapitalH			= kKeyCode_UppercaseH,
	kKeyCode_CapitalI			= kKeyCode_UppercaseI,
	kKeyCode_CapitalJ			= kKeyCode_UppercaseJ,
	kKeyCode_CapitalK			= kKeyCode_UppercaseK,
	kKeyCode_CapitalL			= kKeyCode_UppercaseL,
	kKeyCode_CapitalM			= kKeyCode_UppercaseM,
	kKeyCode_CapitalN			= kKeyCode_UppercaseN,
	kKeyCode_CapitalO			= kKeyCode_UppercaseO,
	kKeyCode_CapitalP			= kKeyCode_UppercaseP,
	kKeyCode_CapitalQ			= kKeyCode_UppercaseQ,
	kKeyCode_CapitalR			= kKeyCode_UppercaseR,
	kKeyCode_CapitalS			= kKeyCode_UppercaseS,
	kKeyCode_CapitalT			= kKeyCode_UppercaseT,
	kKeyCode_CapitalU			= kKeyCode_UppercaseU,
	kKeyCode_CapitalV			= kKeyCode_UppercaseV,
	kKeyCode_CapitalW			= kKeyCode_UppercaseW,
	kKeyCode_CapitalX			= kKeyCode_UppercaseX,
	kKeyCode_CapitalY			= kKeyCode_UppercaseY,
	kKeyCode_CapitalZ			= kKeyCode_UppercaseZ,
	
	kKeyCode_A					= kKeyCode_UppercaseA,
	kKeyCode_B					= kKeyCode_UppercaseB,
	kKeyCode_C					= kKeyCode_UppercaseC,
	kKeyCode_D					= kKeyCode_UppercaseD,
	kKeyCode_E					= kKeyCode_UppercaseE,
	kKeyCode_F					= kKeyCode_UppercaseF,
	kKeyCode_G					= kKeyCode_UppercaseG,
	kKeyCode_H					= kKeyCode_UppercaseH,
	kKeyCode_I					= kKeyCode_UppercaseI,
	kKeyCode_J					= kKeyCode_UppercaseJ,
	kKeyCode_K					= kKeyCode_UppercaseK,
	kKeyCode_L					= kKeyCode_UppercaseL,
	kKeyCode_M					= kKeyCode_UppercaseM,
	kKeyCode_N					= kKeyCode_UppercaseN,
	kKeyCode_O					= kKeyCode_UppercaseO,
	kKeyCode_P					= kKeyCode_UppercaseP,
	kKeyCode_Q					= kKeyCode_UppercaseQ,
	kKeyCode_R					= kKeyCode_UppercaseR,
	kKeyCode_S					= kKeyCode_UppercaseS,
	kKeyCode_T					= kKeyCode_UppercaseT,
	kKeyCode_U					= kKeyCode_UppercaseU,
	kKeyCode_V					= kKeyCode_UppercaseV,
	kKeyCode_W					= kKeyCode_UppercaseW,
	kKeyCode_X					= kKeyCode_UppercaseX,
	kKeyCode_Y					= kKeyCode_UppercaseY,
	kKeyCode_Z					= kKeyCode_UppercaseZ
};

#if !RESOURCEINCLUDE
#define			ToUppercase(Char)	((Char < 'a' || Char > 'z') ? Char : ((Char - 'a') + 'A'))
#define			ToLowercase(Char)	((Char < 'A' || Char > 'Z') ? Char : ((Char - 'A') + 'a'))
#define			ToUpper				ToUppercase
#define			ToLower				ToLowercase
#define			IsAlphabet(Char)	(((Char < 'a' || Char > 'z') && (Char < 'A' || Char > 'Z')) ? false : true)
#define			IsUppercase(Char)	((Char >= 'A' && Char <= 'Z') ? true : false)
#define			IsLowercase(Char)	((Char >= 'a' && Char <= 'z') ? true : false)
#define			IsNumber(Char)		((Char >= '0' && Char <= '9') ? true : false)

#define			ValHexSingle(Char)	(IsNumber(Char) ? Char - '0' :				\
									IsUppercase(Char) ? (Char - 'A') + 0xA :	\
									IsLowercase(Char) ? (Char - 'a') + 0xA :	\
									0)

#define			GetBit32(BitNum)	(1 << (31-BitNum))//bits numbered (left to right) 0 to 31
#define			GetBit16(BitNum)	(1 << (16-BitNum))//bits numbered (left to right) 0 to 15
#define			GetBit8(BitNum)		(1 << (8-BitNum))//bits numbered (left to right) 0 to 7
#define			GetBit				GetBit32

#define			TwosComplement(Value)	((Value ^ 0xFFFFFFFF)+1)

#define 		Beep()				SysBeep(1)

long			ValStr(char *Value);
long			ValHex(char *Value);
void			MyStrCpy(char *Dst, char *Src);
void			MyStrCpy(char *Dst, char *Src, int MaxLength);
int				MyStrLen(char *Str);
int				strlen(Str255 Str);

void			MyPStrToCStr(char *Dst, Str255 Src);
void			MyCStrToPStr(Str255 Dst, char *Src);
bool			MyPStrToUnicode(UniChar Dst[], ByteCount *DstLen, Str255 Src);

void			MyStr(char *Dst, SInt32 Value, int Length);
void			MyUStr(char *Dst, UInt32 Value, int Length);
void			MyHex(char *Dst, UInt32 Value, int Length);
void			MyBin(char *Dst, SInt32 Value, int Length);

void			CopyMem(char *Dst, char *Src, int Length);
void			ZeroMem(char *Dst, int Length);
void			ZeroEndStr(char *Dst, int Length);

UInt32			GetBitField(int StartBit, int EndBit);
UInt32			GetMaskedField(UInt32 Value, int StartBit, int EndBit);

#ifndef ROTATE
#define ROTATE
unsigned long	ROL32(unsigned long var, int numbits);
unsigned long	ROR32(unsigned long var, int numbits);
unsigned short	ROL16(unsigned short var, int numbits);
unsigned short	ROR16(unsigned short var, int numbits);
#endif//ROTATE

#define			EndianSwap32(var)	((ROR32(0x00FF00FF & var, 8)) | (ROL32(0xFF00FF00 & var, 8)))
#define			EndianSwap16(var)	(ROR16(var, 8))

#define			ByteSwap(var)		EndianSwap32(var)//older vers used ByteSwap()

#define			kSecond				((float)(1.0))
#define			kMinute				((float)(60*kSecond))
#define			kHour				((float)(60*kMinute))
#define			kDay				((float)(24*kHour))
#define			kYear				((float)(365*kDay))
#define			kLeapYear			((float)(kYear+kDay))
#define			kFourYears			((float)(kYear+kDay))

enum {
	kMonthJanuary		=	1,
	kMonthFebruary		=	2,
	kMonthMarch			=	3,
	kMonthApril			=	4,
	kMonthMay			=	5,
	kMonthJune			=	6,
	kMonthJuly			=	7,
	kMonthAugust		=	8,
	kMonthSeptember		=	9,
	kMonthOctober		=	10,
	kMonthNovember		=	11,
	kMonthDecember		=	12
};

#define			kMonthStrJanuary			"January"
#define			kMonthStrFebruary			"February"
#define			kMonthStrMarch				"March"
#define			kMonthStrApril				"April"
#define			kMonthStrMay				"May"
#define			kMonthStrJune				"June"
#define			kMonthStrJuly				"July"
#define			kMonthStrAugust				"August"
#define			kMonthStrSeptember			"September"
#define			kMonthStrOctober			"October"
#define			kMonthStrNovember			"November"
#define			kMonthStrDecember			"December"
#define			kMonthStrUnknown			"(UnknownMonth)"

#define			kDayOfWeekStrSunday			"Sunday"
#define			kDayOfWeekStrMonday			"Monday"
#define			kDayOfWeekStrTuesday		"Tuesday"
#define			kDayOfWeekStrWednesday		"Wednesday"
#define			kDayOfWeekStrThursday		"Thursday"
#define			kDayOfWeekStrFriday			"Friday"
#define			kDayOfWeekStrSaturday		"Saturday"
#define			kDayOfWeekStrUnknown		"(UnknownDay)"

/**///todo: use virtual properties
class Date {
public:
	short	Year;			//1904 through 2038 (apparently?)
	short	DayOfYear;		//0 through 364 or 365, on leap year
	char	Month;			//0 through 11
	char	Hour;			//0 through 23
	char	Minute;			//0 through 59
	char	Second;			//0 through 59
	char	DayOfWeek;
	float	TotalSeconds;	//since midnight jan 1, 1904
private:
};
typedef		class Date		Date;

Date * GetDate(float Total);
int YearDayToMonth(short DayOfYear, bool LeapYear);
int YearDayToMonthDay(short DayOfYear, bool LeapYear);
char * GetDayOfWeekStr(int DayOfWeek);
char * GetMonthStr(int Month);

#endif//RESOURCEINCLUDE
#endif//UTILITES

