/*
#include <stdio.h>
//#include <stdlib.h>
#include <String.h>
//#include <time.h>
//#include <Math.h>
//#include <Events.h>
//#include <Dialogs.h>

#include <MacTypes.h>
#include <Controls.h>
#include "Globals.h"
#include "Menus.h"
#include "Windows.h"
#include "Controls.h"
#include "EventLoop.h"
#include "AsmDisplay.h"//includes Mnemomics.h
//#include "MacBnetTools.h"
//#include "MacHashData.h"
//#include "MacCheckRevision.h"
//#include "KBNetwork.h"*/
#include <Carbon.h>
#include <string.h>/**///strlen
#include <stdio.h>/**///sprintf
#include "Debugging.h"
#include "Utilities.h"

long ValStr(char *Value){
#ifdef DEBUGGING
	if (AssertSanity(Value == NULL) == false)
#else
	if (Value == NULL)
#endif
	{
		//assertion failure
		return 0;
	}
	
	int		i, rVal;
	char	Current;
	bool	Negative;
	
	for (i = 0, rVal = 0, Negative = false; i < 10; i++){//i < 10, because both 2 and 4 billion are 10 in length
		Current = Value[i];
		if (Current < '0' || Current > '9'){
			if (i == 0){
				if (Current == '-')
					Negative = true;
				else if (Current == '+')
					Negative = false;
				else
					break;
			} else
				break;
		} else {
			rVal = (rVal * 10) + (Current - '0');
		}
	}
	
	if (Negative == true)
		rVal = TwosComplement(rVal);
	
	return rVal;
}

long ValHex(char *Value){
#ifdef DEBUGGING
	if (AssertSanity(Value == NULL) == false)
#else
	if (Value == NULL)
#endif
	{
		//assertion failure
		return 0;
	}
	
	int		i, rVal;
	char	Current;
	
	for (i = 0, rVal = 0; i < 8; i++){
		Current = ToUpper(Value[i]);
		if (Current < '0' || Current > 'F')
			break;
		rVal = (rVal << 4) | ValHexSingle(Current);
	}
	
	return rVal;
}

void MyStrCpy(char *Dst, char *Src){
	int		i;
	
	i = 0;
	while (Src[i] != 0)
		Dst[i++] = Src[i];
	Dst[i] = 0;/*
	//rather cheesy, but what the hey...
	strcpy(Dst, Src);*/
}

void MyStrCpy(char *Dst, char *Src, int MaxLength){
	int		i;
	
	i = 0;
	while (Src[i] != 0 && i < MaxLength)
		Dst[i++] = Src[i];
	Dst[i] = 0;
}

int MyStrLen(char *Str){
	//rather cheesy, but what the hey...
	return strlen(Str);
}

int strlen(Str255 Str){
	//rather cheesy, but what the hey...
	return strlen((char *)Str);
}


void MyPStrToCStr(char *Dst, Str255 Src){
	char	i;
	
	for (i = 0; i < Src[0]; i++)
		Dst[i] = Src[i+1];
	Dst[i] = 0;
}

void MyCStrToPStr(Str255 Dst, char *Src){
	char	i;
	
	i = 0;
	while (Src[i] != 0 && i <= 255)
		Dst[i] = Src[i++];
	
	if (i > 255)
		i = 255;
	
	Dst[0] = i;
}

bool MyPStrToUnicode(UniChar Dst[], ByteCount *DstLen, Str255 Src){
	OSErr				Error;
	UnicodeMapping		Mapping;
	TextToUnicodeInfo	Info;
	
	Mapping.unicodeEncoding = CreateTextEncoding(kTextEncodingMacUnicode, kTextEncodingDefaultVariant, kTextEncodingDefaultVariant);
	Mapping.otherEncoding = CreateTextEncoding(kTextEncodingMacRoman, kTextEncodingDefaultVariant, kTextEncodingDefaultVariant);
	Mapping.mappingVersion = kUnicodeUseLatestMapping;
	
	Error = CreateTextToUnicodeInfo(&Mapping, &Info);
	if (AssertError2(Error) == false){
		//assertion failure
		return false;
	}
	
	Error = ConvertFromPStringToUnicode(	\
		Info,								\
		Src,								\
		*DstLen,							\
		DstLen,								\
		Dst
	);
	if (AssertError2(Error) == false){
		//assertion failure
		return false;
	}
	
	return true;
}

void MyStr(char *Dst, SInt32 Value, int Length){
	int		i, ValueLength;
	Str15	FormatStr;
	
	if (Length <= 0)
		//no minimum length
		i = 0;
	else {
		if      (Value >= 1000000000 	|| Value <= -1000000000)
			ValueLength = 10;
		else if (Value >= 100000000		|| Value <= -100000000)
			ValueLength = 9;
		else if (Value >= 10000000		|| Value <= -10000000)
			ValueLength = 8;
		else if (Value >= 1000000		|| Value <= -1000000)
			ValueLength = 7;
		else if (Value >= 100000		|| Value <= -100000)
			ValueLength = 6;
		else if (Value >= 10000			|| Value <= -10000)
			ValueLength = 5;
		else if (Value >= 1000			|| Value <= -1000)
			ValueLength = 4;
		else if (Value >= 100			|| Value <= -100)
			ValueLength = 3;
		else if (Value >= 10			|| Value <= -10)
			ValueLength = 2;
		else// if (Value >= 1			|| Value <= -1				|| Value == 0)//9 through -9
			ValueLength = 1;
		
		if (ValueLength < Length){
			//zeros need to be added
			for (i = 0; i < (Length - ValueLength); i++)
				FormatStr[i] = '0';
		} else
			i = 0;//no zeros necessary
	}
	FormatStr[i] = '%';
	FormatStr[i+1] = 'i';
	FormatStr[i+2] = 0;
	
	sprintf(Dst, (char *)FormatStr, Value);
}

void MyUStr(char *Dst, UInt32 Value, int Length){
	int		i, ValueLength;
	Str15	FormatStr;
	
	if (Length <= 0)
		//no minimum length
		i = 0;
	else {
		if      (Value >= 1000000000)
			ValueLength = 10;
		else if (Value >= 100000000)
			ValueLength = 9;
		else if (Value >= 10000000)
			ValueLength = 8;
		else if (Value >= 1000000)
			ValueLength = 7;
		else if (Value >= 100000)
			ValueLength = 6;
		else if (Value >= 10000)
			ValueLength = 5;
		else if (Value >= 1000)
			ValueLength = 4;
		else if (Value >= 100)
			ValueLength = 3;
		else if (Value >= 10)
			ValueLength = 2;
		else// if (Value >= 1			|| Value <= -1				|| Value == 0)//9 through -9
			ValueLength = 1;
		
		if (ValueLength < Length){
			//zeros need to be added
			for (i = 0; i < (Length - ValueLength); i++)
				FormatStr[i] = '0';
		} else
			i = 0;//no zeros necessary
	}
	FormatStr[i] = '%';
	FormatStr[i+1] = 'u';
	FormatStr[i+2] = 0;
	
	sprintf(Dst, (char *)FormatStr, Value);
}

void MyHex(char *Dst, UInt32 Value, int MinimumLength){
	int		i, Counter;
	UInt32	Temp;
	bool	FoundAOne;
	
	if (MinimumLength <= 0){
		MinimumLength = 0;
	}
	
	FoundAOne = false;
	Counter = 0;
	for (i = 28; i >= 0; i -= 4){
		Temp = Value & (0xF << i);//check the bits from left to right
		if (Temp != 0 && FoundAOne == false){
			FoundAOne = true;
		}
		if (FoundAOne == true || (i/4) < MinimumLength){
			Temp >>= i;
			switch (Temp){
				case 0x0:
					Dst[Counter] = '0';
					break;
				case 0x1:
					Dst[Counter] = '1';
					break;
				case 0x2:
					Dst[Counter] = '2';
					break;
				case 0x3:
					Dst[Counter] = '3';
					break;
				case 0x4:
					Dst[Counter] = '4';
					break;
				case 0x5:
					Dst[Counter] = '5';
					break;
				case 0x6:
					Dst[Counter] = '6';
					break;
				case 0x7:
					Dst[Counter] = '7';
					break;
				case 0x8:
					Dst[Counter] = '8';
					break;
				case 0x9:
					Dst[Counter] = '9';
					break;
				case 0xA:
					Dst[Counter] = 'A';
					break;
				case 0xB:
					Dst[Counter] = 'B';
					break;
				case 0xC:
					Dst[Counter] = 'C';
					break;
				case 0xD:
					Dst[Counter] = 'D';
					break;
				case 0xE:
					Dst[Counter] = 'E';
					break;
				case 0xF:
					Dst[Counter] = 'F';
					break;
				default:
					Dst[Counter] = '?';
					break;
			}
			Counter++;
		}
	}
	if (Counter == 0){
		Dst[0] = '0';
		Dst[Counter+1] = 0;
	} else
		Dst[Counter] = 0;
}

void MyBin(char *Dst, SInt32 Value, int MinimumLength){
	int		i, Counter, Temp;
	bool	FoundAOne;
	
	if (MinimumLength <= 0){
		MinimumLength = 1;
	}
	
	FoundAOne = false;
	Counter = 0;
	for (i = 31; i >= 0; i--){
		Temp = Value & (1 << i);//check the bits from left to right
		if (Temp != 0 && FoundAOne == false){
			FoundAOne = true;
		}
		if (FoundAOne == true || i < MinimumLength){
			if (Temp == 0)
				Dst[Counter] = '0';
			else
				Dst[Counter] = '1';
			Counter++;
		}
	}
	if (Counter == 0){
		Dst[0] = '0';
		Dst[Counter+1] = 0;
	} else
		Dst[Counter] = 0;
}

void CopyMem(char *Dst, char *Src, int Length){
	int		i;
	
/**///Would probably be faster to use 32bit zero-ing (64bit under the G5, and etc) until ((Length - i) < 4)
	for (i = 0; i < Length; i++){
		Dst[i] = Src[i];
	}
}

void ZeroMem(char *Dst, int Length){
	int		i;
	
/**///Would probably be faster to use 32bit zero-ing (64bit under the G5, and etc) until ((Length - i) < 4)
	for (i = 0; i < Length; i++){
		Dst[i] = 0;
	}
}

void ZeroEndStr(char *Dst, int Length){
	int		i, StrLen;
	
	StrLen = strlen(Dst);
	for (i = 0; i < Length; i++)
		Dst[StrLen+i] = 0;
}


UInt32 GetBitField(int StartBit, int EndBit){
	int i, rVal;
	
	rVal = 0;
	for (i = StartBit; i <= EndBit; i++)
		rVal += GetBit(i);
	
	return rVal;
}

UInt32 GetMaskedField(UInt32 Value, int StartBit, int EndBit){
	int rVal;
	
	rVal = GetBitField(StartBit, EndBit);
	rVal &= Value;
	rVal >>= 31-EndBit;
	
	return rVal;
}

unsigned long	ROL32(unsigned long var, int numbits){ return ((var << numbits) | (var >> (32 - numbits))); }
unsigned long	ROR32(unsigned long var, int numbits){ return ((var >> numbits) | (var << (32 - numbits))); }
unsigned short	ROL16(unsigned short var, int numbits){ return ((var << numbits) | (var >> (16 - numbits))); }
unsigned short	ROR16(unsigned short var, int numbits){ return ((var >> numbits) | (var << (16 - numbits))); }

/**///todo: find a Carbon API for this!!
Date * GetDate(float Total){
	bool		IsLeapYear;
	Date		*theDate;
	
	theDate = new Date;
	if (AssertCreation(theDate == NULL) == false){
		//assertion failure
		return NULL;
	}
	theDate->TotalSeconds = Total;
	
	theDate->DayOfWeek = (floor(Total/kDay)+5);		//Jan 1, 1904 was a Friday
	theDate->DayOfWeek %= 7;
	//unfortunately, this algorithm is not correct for all years (eg, 2100, 2200, 2300, etc)
	theDate->Year = floor(Total/(kLeapYear+kYear+kYear+kYear));
	Total -= (theDate->Year*(kLeapYear+kYear+kYear+kYear+kYear));
	theDate->Year *= 4;
	
	if (Total >= kLeapYear){
		theDate->Year++;
		Total -= kLeapYear;
	}
	if (Total >= kYear){
		theDate->Year++;
		Total -= kYear;
	}
	if (Total >= kYear){
		theDate->Year++;
		Total -= kYear;
	}
	if (Total >= kYear){
		theDate->Year++;
		Total -= kYear;
	}
	
	theDate->Year += 1904;
	
	if ((theDate->Year % 4) == 0)
		if ((theDate->Year % 100) == 0)
			if ((theDate->Year % 400) == 0)
				IsLeapYear = true;
			else
				IsLeapYear = false;
		else
			IsLeapYear = true;
	else
		IsLeapYear = false;
	
	//Leapyear: Every 4 years, except every 100 years unless the 100 years is divisible by 400
	theDate->DayOfYear = floor(Total/kDay);
	Total -= (theDate->DayOfYear*kDay);
	if (IsLeapYear){
		if (AssertSanity(theDate->DayOfYear > 365) == false){
			//assertion failure
			AssertUnhandledValue2(true, *theDate);
		}
	} else {
		if (AssertSanity(theDate->DayOfYear > 364) == false){
			//assertion failure
			AssertUnhandledValue2(true, *theDate);
		}
	}
	
	theDate->Hour = floor(Total/kHour);
	Total -= (theDate->Hour*kHour);
	if (AssertSanity(theDate->Hour > 23) == false){
		//assertion failure
		AssertUnhandledValue2(true, *theDate);
	}
	theDate->Minute = floor(Total/kMinute);
	Total -= (theDate->Minute*kMinute);
	if (AssertSanity(theDate->Minute > 59) == false){
		//assertion failure
		AssertUnhandledValue2(true, *theDate);
	}
	theDate->Second = floor(Total/kSecond);
	Total -= (theDate->Minute*kSecond);
	if (AssertSanity(theDate->Second > 59) == false){
		//assertion failure
		AssertUnhandledValue2(true, *theDate);
	}
	if (AssertSanity(Total > 0) == false){
		//assertion failure
	}
	
	return theDate;
}

int YearDayToMonth(short DayOfYear, bool LeapYear){
	if (AssertSanity(DayOfYear < 0) == false){
		//assertion failure
		return -1;
	}
	
	if (DayOfYear >= 0 && DayOfYear <= 30)
		return kMonthJanuary;
	DayOfYear -= 31;
	if (LeapYear)
		if (DayOfYear <= 27)
			return kMonthFebruary;
		else
			DayOfYear -= 28;
	else
		if (DayOfYear <= 28)
			return kMonthFebruary;
		else
			DayOfYear -= 29;
	if (DayOfYear <= 30)
		return kMonthMarch;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return kMonthApril;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return kMonthMay;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return kMonthJune;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return kMonthJuly;
	DayOfYear -= 31;
	if (DayOfYear <= 30)
		return kMonthAugust;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return kMonthSeptember;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return kMonthOctober;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return kMonthNovember;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return kMonthDecember;
	DayOfYear -= 31;
	
	return -1;
}

int YearDayToMonthDay(short DayOfYear, bool LeapYear){
	if (AssertSanity(DayOfYear < 0) == false){
		//assertion failure
		return -1;
	}
	DayOfYear++;//expects 0-based input
	
	if (DayOfYear >= 0 && DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	if (LeapYear)
		if (DayOfYear <= 27)
			return DayOfYear;
		else
			DayOfYear -= 28;
	else
		if (DayOfYear <= 28)
			return DayOfYear;
		else
			DayOfYear -= 29;
	if (DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return DayOfYear;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return DayOfYear;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	if (DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return DayOfYear;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	if (DayOfYear <= 29)
		return DayOfYear;
	DayOfYear -= 30;
	if (DayOfYear <= 30)
		return DayOfYear;
	DayOfYear -= 31;
	
	return -DayOfYear;
}

char * GetDayOfWeekStr(int DayOfWeek){
	if (AssertSanity(DayOfWeek < 0) == false){
		//assertion failure
		return kDayOfWeekStrUnknown;
	}
	
	switch (DayOfWeek){
	case 1:
		return kDayOfWeekStrSunday;
	case 2:
		return kDayOfWeekStrMonday;
	case 3:
		return kDayOfWeekStrTuesday;
	case 4:
		return kDayOfWeekStrWednesday;
	case 5:
		return kDayOfWeekStrThursday;
	case 6:
		return kDayOfWeekStrFriday;
	case 7:
		return kDayOfWeekStrSaturday;
	default:
		return kDayOfWeekStrUnknown;
	}
}

char * GetMonthStr(int Month){
	if (AssertSanity(Month < 0) == false){
		//assertion failure
		return kMonthStrUnknown;
	}
	
	switch (Month){
	case 1:
		return kMonthStrJanuary;
	case 2:
		return kMonthStrFebruary;
	case 3:
		return kMonthStrMarch;
	case 4:
		return kMonthStrApril;
	case 5:
		return kMonthStrMay;
	case 6:
		return kMonthStrJune;
	case 7:
		return kMonthStrJuly;
	case 8:
		return kMonthStrAugust;
	case 9:
		return kMonthStrSeptember;
	case 10:
		return kMonthStrOctober;
	case 11:
		return kMonthStrNovember;
	case 12:
		return kMonthStrDecember;
	default:
		return kMonthStrUnknown;
	}
}


